using System.Collections.Generic;
using BansheeGz.BGDatabase;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

//pickup container slot
public class SlotContainer : DbGoItem, IPointerDownHandler, UiManager.IUpdatableUi
{
    //serializable
    public Image itemIcon;
    public Image amountIcon;
    public Text amountText;

    //non serializable
    private SlotAbstract abstractSlot;

    public override void EntityChanged() => UpdateUi();

    public void UpdateUi()
    {
        Utils.Assign(ref abstractSlot, () => new SlotAbstract(itemIcon, amountIcon, amountText));
        if (Entity == null) abstractSlot.UpdateUi(null, 0);
        else abstractSlot.UpdateUi((f_item).f_icon, f_count);
    }


    // On Mouse Click
    public void OnPointerDown(PointerEventData eventData)
    {
        if (Entity == null || f_item == null) return;

        var chestItem = (DbItem)Entity;

        var leftAmount = new InventoryContainer().TryToAdd(chestItem, chestItem.f_count == 0 ? 1 : chestItem.f_count);

        if (leftAmount != 0) UiManager.ShowAlert("Inventory is full");
    }
}